#include "Agent.hh"
#include "X11_With_Color.cpp"

double   Agent::labdavol;
double   Agent::labdasurf;
double   Agent::invT;
int      Agent::volume_divide_1;
int      Agent::volume_divide_2;
int		 Agent::shrink_rate;
int 	 Agent::Y_growth_contribution;
float    Agent::death_rate;
float	 Agent::init_X;
float	 Agent::init_Y;
float	 Agent::rY;
float	 Agent::rX;
float	 Agent::bxx;
float	 Agent::byy;
float	 Agent::bxy;
float	 Agent::byx;
float	 Agent::dX;
float	 Agent::dY;
float	 Agent::noise;
float	 Agent::speed_internal_dynamics;
float    Agent::delta_time;
int		 Agent::color_sensitivity;
int      Agent::targetsurface;
int      Agent::surfaceconstraint; //flag to see if a surfaceconstraint is used.
int      Agent::L;               //grid length
int      Agent::W;               //grid width
int      Agent::neighbourhoodsize; //if neighbourhoodsize is given as 0, the Moore neighbourhood is used. Necessary when using DeltaSurfHamiltonian
int      Agent::MaxNrCells;      //256
Position* Agent::wideneighbourhood;  //array holding the positions of the wider neighbourhood used for hamiltonian stuff
int      Agent::InitNrCells_1;
int      Agent::InitNrCells_2;
int      Agent::Binom_div;
int      Agent::NrDevSteps;
int**    Agent::JTable;

extern int Xzoom;

Agent::Agent()
{
  CellArray.clear();
  piccounter=0;
  piccounter2=0;
  anrcells_=0;

  CreateField();



}

Agent::~Agent()
{
  CellArray.clear();

  DestroyField();


   free(JTable[0]);
   free(JTable);
}



//place initial cells in the field; if you need info on contacts between cells, use InitContactLength afterwards
void Agent::PutCellsInField()
{
  ///create medium as special cell type
  CellArray.insert(make_pair(0, Cell()));
  CellArray[0].CreateCell(0,0);

  ///create normal cells
  int zz, ii,jj;
  static int LL=L-15;
  static int WW=W-15;

    int i=0, attempts=0;
    while(i<InitNrCells_2)
    {
      zz=(int)(0.1+0.8*uniform()*(LL*WW*8));
      ii=zz/(WW*8);
      jj=(zz-ii*WW*8)/8;
      i+=PlaceOneCell(2,i+1,ii+5, jj+5);
      attempts++;
      if(attempts > 1000)
      {
        cout << "Tried to place a cell 1000 times, but it doesn't fit on the grid. Exiting program." << endl;
        exit(0);
      }
    }

    while(i<InitNrCells_1+InitNrCells_2)
      {
          zz=(int)(0.1+0.8*uniform()*(LL*WW*8));
          ii=zz/(WW*8);
          jj=(zz-ii*WW*8)/8;
          i+=PlaceOneCell(1,i+1,ii+5, jj+5);
          if(attempts > 1000)
          {
            cout << "Tried to place a cell 1000 times, but it doesn't fit on the grid. Exiting program."<< endl;
            exit(0);
          }
      }

}

void Agent::DevelopAgent(char *show)//run the CPM dynamics + whatever else needs to happen meanwhile (divisions, network updates, pictures)
{

  PutCellsInField();
  ClearTable();


  for(int step=0; step<NrDevSteps; step++)
  {
    /// update the CPM
   UpdateAgent_Random();
   float sumX1 = 0.0, sumX2 = 0.0;
   float sumY1 = 0.0, sumY2 = 0.0;
   int sumvol1 = 0, sumvol2 = 0;
   int sumtarvol1 = 0, sumtarvol2 = 0;
   int countcells = 0, cc1=0, cc2=0;
   //float minX1 = 99999999;
   //float minX2 = 99999999;
   float minY1 = 99999999;
   float minY2 = 99999999;



   map<int, Cell>::iterator it;
   for(it=CellArray.begin(); it!=CellArray.end(); ++it)
     {
	   	   // BIRTH OF CPM CELLS
	   	  if(it->second.vol > it->second.divvol){
	   		 CleaveSingleCell(it->second.id);
	   	  }
	   	  //   DEATH OF CPM CELLS
	   	     	  if(uniform() < death_rate){	// Marked for death by setting age to 999999
	   	    		 it->second.age=9999999;
	   	   	  }
           // BOOK KEEPING OF SOME FEATURES TO PRINT IN TERMINAL

	   	  if(it->second.vol > 0) {
	   		  if(it->second.celltype==1)
	   		  {
	   			sumX1 += it->second.X;
	   			sumY1 += it->second.Y;
                if(it->second.Y < minY1) minY1 = it->second.Y;
	   			sumvol1 += it->second.vol;
	   			sumtarvol1 += it->second.tarvol;
	   			cc1++;
	   		  }
	   		  else
	   		  {
	   			sumX2 += it->second.X;
				sumY2 += it->second.Y;
                if(it->second.Y < minY2) minY2 = it->second.Y;
				sumvol2 += it->second.vol;
				sumtarvol2 += it->second.tarvol;
				cc2++;
	   		  }

	   		  countcells++;
	   	  }

     }



   int divideby = 2;
   float avgvol1 = ((sumvol1)/float(cc1));
   float avgvol2 = ((sumvol2)/float(cc2));
   float avg_X1 = sumX1/float(cc1);
   float avg_Y1 = sumY1/float(cc1);
   float avg_X2 = sumX2/float(cc2);
   float avg_Y2 = sumY2/float(cc2);
   float avg_tarvol1 = sumtarvol1/float(cc1);
   float avg_tarvol2 = sumtarvol2/float(cc2);


   float avgY1c =  (((sumY1)/float(cc1)));
   float avgY2c =  (((sumY2)/float(cc2)));

   if(isnan(avgY1c)) avgY1c = 0.0, divideby--;
   if(isnan(avgY2c)) avgY2c = 0.0, divideby--;
   if(isnan(avg_X1)) avg_X1 = 0;
   if(isnan(avg_X2)) avg_X2 = 0;
   if(isnan(avg_Y1)) avg_Y1 = 0;
   if(isnan(avg_Y2)) avg_Y2 = 0;
   if(isnan(avg_tarvol1)) avg_tarvol1 = 0;
   if(isnan(avg_tarvol2)) avg_tarvol2 = 0;
   if(isnan(avgvol1)) avgvol1 = 0;
   if(isnan(avgvol2)) avgvol2 = 0;

   char mystring[500];


   sprintf(mystring,"%d %d %d %f %f %f %f %f  %f", step, cc1, cc2, avg_Y1,avg_Y2,avgvol1,avgvol2,avg_tarvol1,avg_tarvol2);
   string realstring = mystring;
   SaveTable(realstring);

   DisplayGrid(step);     // Displays grid


   //cout << avgY1c << endl;
   DrawBar( (avgY1c), (avgY2c));
   CatchEvents();     // Detects mouse clicks and keyboard presses. You can even detect which pixel is clicked.
   if(step%4000==0)
   {
    printf("TIME\t\tCELL1\t\tCELL2\t\tY1\t\tY2\t\tVOL1\t\tVOL2\t\tTARVOL1\t\tTARVOL2\n");
    //sleep(1);
   }
   if(step%100==0)
   {
    printf("%d\t\t%d\t\t%d\t\t%.3f\t\t%.3f\t\t%.3f\t\t%.3f\t\t%.3f\t\t%.3f\n", step, cc1, cc2, avg_Y1,avg_Y2,avgvol1,avgvol2,avg_tarvol1,avg_tarvol2);
    //sleep(1);
   }

   UpdateCellProps();

   if(strlen(show)>1)
   {
	 Snapshot(Xzoom,show);
   }

  }

}

void Agent::UpdateCellProps()
{
  map<int, Cell>::iterator it;

      for(it=CellArray.begin(); it!=CellArray.end(); ++it)
      {
        int& vol = it->second.vol;
        int& divvol = it->second.divvol;
        int& tarvol = it->second.tarvol;
    	float curX = it->second.X;
    	float curY = it->second.Y;


        float& X = it->second.X;
        float& Y = it->second.Y;

    	//it->second.age++;
        if(it->second.age >= 999999999) it->second.tarvol-=1; // Shrinks if marked for death
        else  { // Grow if not
    		#include "../Celldynamics.cc"
        }

        if (X < 0.0) X = 0.0;
        if (Y < 0.0) Y = 0.0;
        if (tarvol < 0) tarvol = 0;
    }


}



double Agent::Extra(int i,int j, int ii, int jj)//here you can expand the Hamiltonian with more functions
{

  int idA, idB;

  double DYield=0;

  //cell id's of the cell into which you are copying (A), and the cell which is copying (B)
  idA=CellIdGrid[i][j];
  idB=CellIdGrid[ii][jj];


  DYield=0;


  return DYield;
}

void Agent::After(int i,int j, int ii, int jj)//extra book keeping if you need it.
{
  int idA, idB;
  idA=CellIdGrid[i][j];
  idB=CellIdGrid[ii][jj];

  ///use this if positional and/or shape info is required (e.g. if you need divisions); take care of dead cells.
  if(idA){
    if(CellArray[idA].vol<1)
    {
      //printf("cell %d has no vol!\n",idA);
      CellArray.erase(idA);
    }
    else
      CellArray[idA].UpdateCellPixel(i,j,-1);
  }
  if(idB){
    if(CellArray[idB].vol<1)
    {
      //printf("cell %d has no vol!\n",idB);
      CellArray.erase(idB);
    }
    else
      CellArray[idB].UpdateCellPixel(i,j,1);

  }






}

int Agent::PlaceOneCell(int type, int id, int ipos, int jpos)//cell type, cell id, i position, j position
{
  // int stripelength=20; //nr of cells over the length of a stripe
  int i, j,m;

  //check if spot is taken.
  for(i=-2;i<=2;i++)
  {
    for(j=-2;j<=2;j++)
    {
      if(CellIdGrid[ipos+i][jpos+j])
      {
	       printf("Agent:PlaceOneCell is asked to place cell %d on top of another. Use fewer cells, or a bigger grid. (exiting)\n",id);
	       return 0;
      }
    }
  }

  if(!CellArray.count(id))
  {
    CellArray.insert(make_pair(id, Cell()));
    CellArray[id].CreateCell(id, type);
    printf("created cell\n");

  }
  else
  {
    printf("Agent:PlaceOneCell: cell of this id already exists. exiting...\n");
    exit(1);
  }

  for(i=-2;i<=2;i++)
  {
    for(j=-2;j<=2;j++)
    {
      CellIdGrid[ipos+i][jpos+j]=id;
      CellArray[id].UpdateMoments(ipos+i,jpos+j,1);
      CellArray[id].vol++;
    }
  }

  if(type == 1){
	  CellArray[id].X=init_X;
	  CellArray[id].Y=init_Y;
	  CellArray[id].tarvol= CellArray[id].vol*2;
  	  CellArray[id].divvol=volume_divide_1;
  }
  else{
	  CellArray[id].X=init_X;
	  CellArray[id].Y=init_Y;
	  CellArray[id].tarvol= CellArray[id].vol*2;
	  CellArray[id].divvol=volume_divide_2;
  }

  if(surfaceconstraint){
    for(i=-2;i<=2;i++)
      for(j=-2;j<=2;j++)
	for(m=0;m<neighbourhoodsize;m++){
	  if(CellIdGrid[ipos+i+wideneighbourhood[m].yy][jpos+j+wideneighbourhood[m].xx]!=CellIdGrid[ipos+i][jpos+j])
	    CellArray[id].surf++;
	}
    CellArray[id].tarsurf=targetsurface;
  }
  CellArray[id].UpdateCell();
  anrcells_++;
  return 1;
}


void Agent::CreateAgentManyCells(int number, int type, int clumped) //creates a number of cells of a certain type
{
  int i, j, k, m,p,q, l=0;
  int ny, nx;
  int occupied=0, attempts;

  if (clumped){

    int counter=1;
    //determine block size
    while(number-counter*counter>0){
      counter++;
    }
    int iborder=(L-7*counter)/2;
    int jborder=(W-7*counter)/2;

    if(iborder<5 ||jborder<5){
      printf("CreateAgentManyCells:error: too many cells, they cannot be placed\n");
      return;
    }

    int placed=1;
    for(p=0;p<counter;p++){

      if(placed>number)
	break;

      for(q=0;q<counter;q++){

	if(placed>number)
	  break;

	ny=iborder+2+7*p;
	nx=jborder+2+7*q;

	if(!CellArray.count(placed))
	{
	  CellArray.insert(make_pair(placed, Cell()));
	  CellArray[placed].CreateCell(placed, type);

	}
	else
	{
	  printf("Agent:CreateAgentManyCells: cell of this id already exists. exiting...\n");
	  exit(1);
	}

	for(i=-2;i<=2;i++)
	  for(j=-2;j<=2;j++){
	    CellIdGrid[ny+i][nx+j]=placed;
	    CellArray[placed].UpdateMoments(ny+i,nx+j,1);
	    CellArray[placed].vol++;
	  }


	CellArray[placed].tarvol=volume_divide_1;

	if(surfaceconstraint){
	  for(i=-2;i<=2;i++)
	    for(j=-2;j<=2;j++)
	      for(m=0;m<neighbourhoodsize;m++){
		if(CellIdGrid[ny+i+wideneighbourhood[m].yy][nx+j+wideneighbourhood[m].xx]!=CellIdGrid[ny+i][nx+j])
		  CellArray[placed].surf++;
	      }
	  CellArray[placed].tarsurf=targetsurface;
	}
	CellArray[placed].UpdateCell();
	placed++;
	anrcells_++;
      }
    }
  }


  else{
    //first test which cell ids have not been used yet
    int start=1;
    while(CellArray[start].tarvol){
      start++;
    }

    for(k=start;k<=number+start; k++){

      CellArray[k].CreateCell(k,type); //give the id, type and delay

      do{
	occupied=0;

	ny=(int)(uniform()*((double)(L-14))); //pick a random position, taking the unupdated border into account
	nx=(int)(uniform()*((double)(W-14)));
	ny+=5+2;
	nx+=5+2;

	//printf("y=%d, x=%d\n",ny,nx);

	for(i=-2;i<=2;i++){
	  if(ny+i>=L || ny+i<0){
	    occupied=1;
	    continue;
	  }
	  for(j=-2;j<=2;j++){
	    if(nx+j>=W || nx+j<0){
	      occupied=1;
	      continue;
	    }
	    occupied+=CellIdGrid[ny+i][nx+j];//check whether this position is empty
	    // printf("occupied:%d, counter=%d\n",occupied,l);
	    l++;
	  }
	}
	l=0;

	if(!occupied){ //if not, fill with new cell. Update volume, targetvolume and if necessary, (target) surface

	for(i=-2;i<=2;i++)
	  for(j=-2;j<=2;j++){
	    CellIdGrid[ny+i][nx+j]=k;
	    CellArray[k].UpdateMoments(ny+i,nx+j,1);
	    CellArray[k].vol++;
	  }

	  CellArray[k].tarvol=volume_divide_1;

	if(surfaceconstraint){
	  for(i=-2;i<=2;i++)
	    for(j=-2;j<=2;j++)
	      for(m=0;m<neighbourhoodsize;m++){
		if(CellIdGrid[ny+i+wideneighbourhood[m].yy][nx+j+wideneighbourhood[m].xx]!=CellIdGrid[ny+i][nx+j])
		  CellArray[k].surf++;
	      }
	      CellArray[k].tarsurf=targetsurface;
	}
	CellArray[j].UpdateCell();

	anrcells_++;
	}

      else{
	attempts++;
	if (attempts > 100) {
	  printf("cannot place cell with number %d! exiting...!\n",k);
	  exit(1);
	}
      }
    }while(occupied);
    attempts=0;
    occupied=0;

    }
  }
}


void Agent::UpdateAgent_Random()//Do one monte carlo update step. Random order. Note that it is possible that not all pixels are updated, while others are updated 2x. This should not matter for dynamics.
{
  int I;
  int i,j;
  int ii,jj;
  int idA;
  int idB;
  double extravalue=0;

  for(I=0;I<L*W;I++)
    {
      //draw random site i,j, and random neighbor site
      randomCouple(&i,&j,&ii,&jj);
      idA=CellIdGrid[i][j];
      idB=CellIdGrid[ii][jj];
      if(CellArray[idB].tarvol < 2)
        continue;
      if(idA!=idB)//points belong to different cells, or cell and medium
	{
	  extravalue=Extra(i,j,ii,jj);

	  if(CPMAttempt(i,j,ii,jj,extravalue)==TRUE){//copy action is performed
	    DoCPMUpdate(i,j,ii,jj);
	    After(i,j,ii,jj);
	    //update ids in the plane: was first in DoCPMUpdate, but that is not very convenient: After should also have the original situation
	    CellIdGrid[i][j]=CellIdGrid[ii][jj];
	  }

	}
    }
}

int Agent::UpdateAgent_Mask()//only update small part of the field, where the tissue is.
{
  int I;
  int i,j;
  int ii,jj;
  int idA;
  int idB;
  double extravalue=0;
  int imin, imax, jmin, jmax;
  //find center of the tissue and its length: only update within those boundaries.
  if(DetermineCollectioninfo(0)==2)
  {
    return 1;
  }
  else
  {
    imin=max(CellArray[0].meani-CellArray[0].ReturnMajorAxisLength()/2-10, 5.);
    imax=min(CellArray[0].meani+CellArray[0].ReturnMajorAxisLength()/2+10, (double)L-6.);
    jmin=max(CellArray[0].meanj-CellArray[0].ReturnMajorAxisLength()/2-10, 5.);
    jmax=min(CellArray[0].meanj+CellArray[0].ReturnMajorAxisLength()/2+10, (double)W-6.);

    int pixelnr=(imax-imin+1)*(jmax-jmin+1);

    for(I=0;I<pixelnr;I++)
    {
      //draw random site i,j, and random neighbor site
      randomMaskCouple(&i,&j,&ii,&jj, imin, imax, jmin, jmax);
      idA=CellIdGrid[i][j];
      idB=CellIdGrid[ii][jj];
      if(idA!=idB)//points belong to different cells, or cell and medium
	{
	  extravalue=Extra(i,j,ii,jj);

	  if(CPMAttempt(i,j,ii,jj,extravalue)==TRUE){//copy action is performed
	    DoCPMUpdate(i,j,ii,jj);
	    After(i,j,ii,jj);
	    //update ids in the plane: was first in DoCPMUpdate, but that is not very convenient: After should also have the original situation
	    CellIdGrid[i][j]=CellIdGrid[ii][jj];
	  }

	}
    }
    return 0;
  }
}

void Agent::UpdateAgent_Walker()//deprecated; tries to do clever updates by following boundaries. may have scary side-effects.
{
  int I;
  int i,j;
  int NRSTEPS;
  int NRLOST;
  int lost;
  int boundary_;
  int Xi,Xj;
  int NBXi,NBXj;
  int Yi,Yj;
  int NBYi,NBYj;
  int here,there;//randomly chosen point and neighbour
  int Lx=5*(int)sqrt(L);
  int Wx=12*(int)sqrt(W);

  here=0;
  there=0;
  boundary_=FALSE;
  for(I=0;I<Lx;I++)//for(I=0;I<10;I++)
    {
      NRSTEPS=Wx;//25;//NRSTEPS*NRLOST is max nr steps without starting with new random walker
      NRLOST=8;//64;//max nr of attempts to find new boundary point in locality of current one
      // let's find a new boundary point
      while(boundary_==FALSE)
	{
	  randomCouple(&Xi,&Xj,&NBXi,&NBXj);// pick a global random point and neighbour
	  here=CellIdGrid[Xi][Xj];
	  there=CellIdGrid[NBXi][NBXj];
	  if(here!=there)
	    boundary_ = TRUE;
	}
      // boundary found, now we know here and there
      // so let's travel along boundary
      lost = NRLOST;
      Yi=Xi;
      Yj=Xj;
      NBYi=NBXi;
      NBYj=NBXj;
      i = 0;
      j = NRSTEPS * NRLOST;
      while( i != j )
	{
	  if( here != there ) // boundary point
	    {
	      lost = NRLOST;//start over with counting available local attempts
	      Xi=Yi;
	      Xj=Yj;
	      NBXi=NBYi;
	      NBXj=NBYj;
	      if(CPMAttempt(Xi,Xj,NBXi,NBXj,0)==TRUE)
		{
		  DoCPMUpdate(Xi,Xj,NBXi,NBXj);
		}
	    }
	  else // not a boundary point, countdown max number of local attempts
	    --lost;
	  if( lost == 0 ) // stop if boundary lost (maximum nr of local attempts reached)
	    j = i;
	  else // next attempt to find point on local boundary
	    {
	      randomLocalCouple(&Xi,&Xj,&Yi,&Yj,&NBYi,&NBYj);
	      here = CellIdGrid[Yi][Yj];
	      there =CellIdGrid[NBYi][NBYj];
	      i++;
	    }
	}
      //if( j != NRSTEPS * NRLOST )//find out if you left loop becaus of boundary lost or not
      boundary_ = false;
    }
}
